#include <stdio.h>
#include <xview/xview.h>
#include <sys/stat.h>
#include "tool.h"
#include "menu.h"
#include "g.h"
#include "ext.h"
#include "extxv.h"

init_change_edge_label(ie)
Event *ie;
{


	label = label_search(ie->ie_locx, ie->ie_locy);
	if (label == 0) {
		link = link_search(ie->ie_locx, ie->ie_locy);
		if (link == 0) {
			reset_canvas_reader();
			return;
			}
		label = link->label;
		if (label == 0) {
			label = (struct g_label *) malloc(sizeof(struct g_label));
			strcpy(labelname, "");
			label->name = 0;
			label->x = ie->ie_locx;
			label->y = ie->ie_locy;
			label->link = link;
			insert_label(label);
			link->label = label;
		}
	} else {  /* label != 0 */
		if (label->link == 0) {
			put_text_high("It is not a edge label. It is a comment!");
			return;
			}
		strcpy(labelname, label->name);
		free(label->name);
		label->name = 0;
		}
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, label_cursor, 0);
	cur_link = label->link;
	cur_x = label->x;
	cur_y = label->y;
	delete_label(label);
	/* winsetmouseposition(cswfd, cur_x, cur_y); */
	labelptr = strlen(labelname) - 1;
	put_text_higher("Please correct the edge label;");
	put_text_high("   drag it with left button down;");
	put_text("   hit middle button or return to exit.");
	canvas_reader = edge_label_reader;
}

init_change_node_label(ie)
Event *ie;
{

	char buf1[200];

	node = node_search(ie->ie_locx, ie->ie_locy, NODE_TOL);
	if (node == 0) return;
	strcpy(name, node->label);
	sprintf(buf1, "Change node label: the original node label is %s", name);
	fprintf(stderr, "%s\n", buf1);
	xv_set(popupMsg_item, PANEL_LABEL_STRING,
		buf1, 0);
	strcpy(askname, "Please enter the new node label:");
	xv_set(popupData_item, PANEL_LABEL_STRING, askname,
		PANEL_VALUE, name,
		0);
	sw = READING_NODE_LABEL;
	xv_set(subframe, XV_SHOW, TRUE, 0);
}

init_change_initial_node(ie)
Event *ie;
{

	node = node_search(ie->ie_locx, ie->ie_locy, 
		(g->type == PG) ? NODE_TOL : STATE_TOL);
	if (node == 0) return;
	if (node == g->initial_node)  return;
	erase_machine_name();
	erase_initial_node_symbol(g->initial_node);
	g->initial_node  = node;
	draw_initial_node_symbol(g->initial_node);
	draw_machine_name();
	modified();
}

