#include <stdio.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include "tool.h"
#include "g.h"
#include "menu.h"
#include "state.h"
#include "ext.h"


dim_previous_highlight()
{
	if (node_highlighted != NULL) {
		highlight_state_and_node(node_highlighted);
		node_highlighted = NULL;
		}
	if (link_highlighted != NULL) {
		dim_highlight_arc_and_link(link_highlighted);
		link_highlighted = NULL;
		}
}

detail_state_reader(ie)
Event *ie;
{
	ie->ie_locx = ie->ie_locx*zoom - DX;
	ie->ie_locy = ie->ie_locy*zoom - DY;
	switch (ie->ie_code) {
	case MS_LEFT :
		fprintf(stderr, "detail_reader: ie locx=%d, locy=%d\n", ie->ie_locx, ie->ie_locy);
		init_nodemoving(ie);
		if (node == NULL) {
			link = link_search(ie->ie_locx, ie->ie_locy);
			if (link == NULL) return;
			dim_previous_highlight();
			highlight_arc_and_link(link);
			link_highlighted = link;
		} else {
			dim_previous_highlight();
			highlight_state_and_node(node);
			node_highlighted = node;
		}
		break;
	case MS_MIDDLE :
		dim_previous_highlight();
		reset_canvas_reader();
		return;
	}
}
