#define F 0
#define T 1
#include <xview/xview.h>
#include <sys/stat.h>
#include <stdio.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"

int 	tssno;
extern int BB;
extern int WS;


appendoutarc(arcno)
int arcno;
/* append arc arcno to outarclst with no duplicate arc */
{
	struct ARCLST *arc, *f, *b;

	arc = (struct ARCLST *) malloc(sizeof(struct ARCLST));
	arc->arcno = arcno;
	arc->next = NULL;

	for (f = b = outarclst; f != NULL; b = f, f = f->next);
	if (b != NULL)  b ->next = arc;
	else outarclst = arc;
}

appendarc(lst, arcno)
struct ARCLST **lst;
int arcno;
/* append arc arcno to lst */
{
	struct ARCLST *arc, *f, *b;

	arc = (struct ARCLST *) malloc(sizeof(struct ARCLST));
	arc->arcno = arcno;
	arc->next = NULL;

	for (f = b = *lst; f != NULL; b = f, f = f->next);
	if (b != NULL)  b ->next = arc;
	else *lst = arc;
}

append(lst, ssno)
struct STATELST **lst;
int ssno;
/* append state ssno to outstatelst with no duplicate state */
{
	struct STATELST *f, *b;
	struct STATELST *state;


	for (f = b = *lst; f != NULL; b = f, f = f->next)
            if (abs(ssno) == abs(f->ssno)) return;
	state = (struct STATELST *) malloc(sizeof(struct STATELST));
	state->ssno = ssno;
	state->next = NULL;
	if (b != NULL) b->next = state;
	else *lst = state;
}

copy(cssno, ssno)
int cssno, ssno;
/* create a state and copy the data in ssno to this new state */
{
   int 	i;

   for (i = 1; i > -1; i--) {
      ss[cssno].pn[i] = ss[ssno].pn[i];
      strcpy(ss[cssno].c[i].m, ss[ssno].c[i].m);
      }
   ss[cssno].property[0] = (char) 0;
   ss[cssno].in = NULL;
   ss[cssno].out = NULL;
   ss[cssno].parentarcno = -1;
}


createss(e, i, ssno)
struct g_link *e;
int i, ssno;
{
	if (++cssno > MAXSSNO) {
	   put_text("*** System state overflow! increase MAXSSNO & recompile");
	   return(1);
	   }
	copy(cssno,ssno);
	ss[cssno].pn[i] = e->dst_port.node->no;
	return(0);
}

existeq(oldssno, cssno)
int cssno, *oldssno;
/* return F if there is no state which has the same content as ss[cssno] */
{
   register i;

   for (i = 0; i < cssno ; i++) 
      if (ss[cssno].pn[1] == ss[i].pn[1])
	 if (ss[cssno].pn[0] == ss[i].pn[0])
	    if (strcmp(ss[cssno].c[1].m, ss[i].c[1].m) == 0)
	       if (strcmp(ss[cssno].c[0].m, ss[i].c[0].m) == 0)
		  break;
   if (i == cssno) { *oldssno = 0; return(0);}
   *oldssno = i;
   return(1);
}



insertunexpl(lst, rgno)
int rgno;
struct STATELST		*lst;
{
   struct STATELST	*f, *b;

   for (f = b = lst; f != NULL; ) {
       int ssn;

       ssn = abs(f->ssno);
       if (ssn == 99999) ssn = 0;
       if (ss[ssn].out == NULL) {
	  b = f;
	  f = f->next;
	  continue;
	  }
	  /* already explored */
       if (f == b) { 
	  f = f->next;
	  free(b);
	  b = f;
	  lst = b;
	  }
       else {
	  b->next = f->next;
	  free(f);
	  f = b->next;
	  }
	}
   rg[rgno]->unexpstatelst = lst;
}

insertarc(i, e, dssno, ssno)
int	i, dssno, ssno;
struct g_link	*e;
{
   struct ARCLST *al;

   if (++arc_no > MAXARCNO) {
      put_text("*** ARC array overflow! increase MAXARCNO & recompile.");
      return(1);/* abnormal */
      }
   arc[arc_no].srcssno = ssno;
   arc[arc_no].dstssno = dssno;
   sprintf(arc[arc_no].label,"P%d%c%c", (i == 1) ? 1 : 2, 
           (e->label->name[0] == '-' || e->label->name[0] == '+') ?  e->label->name[0] : ' ',
	    e->label->abn);
	
   arc[arc_no].processno = (i == 1) ? 1 : 0;
   arc[arc_no].edgeno = e->no;
   appendarc(&(ss[ssno].out), arc_no);
   if (dssno < 0) dssno = -dssno;
   if (dssno == 99999) dssno = 0;
   appendarc(&(ss[dssno].in), arc_no);
   return(0); /*normal*/
}

newssarc(se, i, ssno, rgno)
struct g_link *se;
int i, ssno, rgno;
{
   char CH[11];
   int  tssno, oldssno;

	/* sanity check */
   if (se->label->name[0] == '-')  { /* send event */
   		if (strlen(ss[ssno].c[i].m) >= BB) {
   		   put_text("*** channel overflow when expand system state");
     	   return(1);
      	}
		/* check window size */
		if (strlen(ss[ssno].c[i].m) >= WS) return(1);
   }
   if (createss(se, i, ssno)) return(1); 

   /* create a new state in cssn, after cssno++ */
   /* send msg to channel i of state cssno; */
   
   if (se->label->name[0] == '-') {
      CH[0] = se->label->abn;
      CH[1] = (char) 0;
      strcat(ss[cssno].c[i].m, CH);
      }
   if (existeq(&oldssno, cssno)) {
      cssno--;
      tssno = (oldssno == 0) ? -99999 : -oldssno;
      }
   else {
      ss[cssno].parentarcno = arc_no + 1;
      tssno = cssno;
      checkproperty(tssno, rgno);
      }
   append(&outstatelst, tssno);
   if (insertarc(i, se, tssno, ssno)) return(1);
   appendoutarc(arc_no);
   return(0);
}

rcvnode(n)
struct g_node	*n;
{
	   struct g_link	*e;

	   e = n->outlink;
	   if (e == NULL) return(F);/* it's a final node */
	   for (; e != NULL; e = e->outlink) 
	      if (e->label->name[0] != '+') return(F); /* sending node or
							  mixed node */
	   return(T);
}

finalnode(n)
struct g_node 	*n;
{
	if (n->outlink == NULL) return(T);
	return(F);
}

checkproperty(ssno, rgno)
int ssno, rgno;
{
	int i, j;
	int UNSP[2];
	struct g_node *n[2];

	if (ssno < 0) ssno = -ssno;
	if (ssno == 99999) ssno = 0;

	for (i = 1; i > -1; i--) {
	UNSP[i] = F;
	n[i] = search_node(P[i].g, ss[ssno].pn[i]);
	j = (i == 1) ? 0 : 1;
	/* get the first msg from channel c[j], input channel of P[i] */
	/* see if there is outgoing edge that can receive this msg    */
	if (strlen(ss[ssno].c[j].m) != 0) {
	   struct g_link	*re;  /* receiving edge */
	   int    progress;

	   progress = F;
	   for (re = n[i]->outlink; re != NULL; re = re->outlink) {
	      /* skip sending edges */
	      if (re->label->name[0] == '-') { progress = T; break;}
	      if (ss[ssno].c[j].m[0] == re->label->abn) {
	         re->reachable = 1;
		 progress = T;
		 break;
		 }
	      }
	   if (progress == F) {
	      if (rcvnode(n[i]) ||
	          finalnode(n[i])) {
		  UNSP[i] = T;
		 }
	      }
	   } /* end of if c[j] not empty */
	} /* for */
	/* test deadlock & proper termination */
	if (((UNSP[1] == T) && (UNSP[0] == T)) 
	    ||
	    ((UNSP[1] == T) && ((rcvnode(n[0]) || finalnode(n[0])) &&
				(strlen(ss[ssno].c[1].m) == 0)))
	    ||
	    ((UNSP[0] == T) && ((rcvnode(n[1]) || finalnode(n[1])) &&
				(strlen(ss[ssno].c[0].m) == 0)))
	   ) {
		 strcpy(ss[ssno].property, "Unspecified_reception");
		 append(&(rg[rgno]->unspecified_reception), ssno);
	     }
	if ((strlen(ss[ssno].c[1].m) == 0) && (strlen(ss[ssno].c[0].m) == 0)) {
	   if (rcvnode(search_node(P[1].g, ss[ssno].pn[1])) &&
	       rcvnode(search_node(P[0].g, ss[ssno].pn[0]))    ) {
	       strcpy(ss[ssno].property, "Deadlock");
	       append(&(rg[rgno]->deadlock), ssno);
	       }
	   if (finalnode(search_node(P[1].g, ss[ssno].pn[1])) &&
	       finalnode(search_node(P[0].g, ss[ssno].pn[0]))    ) {
	       strcpy(ss[ssno].property, "Proper_termination");
	       append(&(rg[rgno]->proper_termination), ssno);
	       }
	   }
}


explore1state(ssno, rgno)
int ssno,rgno;
{
	int i, j;

	if (ssno < 0) ssno = -ssno;
	if (ssno == 99999) ssno = 0;
	if (ss[ssno].out != NULL) return(0); /* already explored */
	if (ss[ssno].property[0] == 'D' || ss[ssno].property[0] == 'P' )
	   return(0);
	/*
	fprintf(stderr, "ss[%d]=[%d, %d, %s, %s]\n", ssno, ss[ssno].pn[1], 
		ss[ssno].pn[0], ss[ssno].c[1].m, ss[ssno].c[0].m);
	*/
	for (i = 1; i > -1; i--) {
	   /* find outgoing sending or internal transition edges of P[i] */
	   struct g_link	*se;
	   struct g_node 	*node;

	   node = search_node(P[i].g, ss[ssno].pn[i]);
	   se = node->outlink;
	   for (; se != NULL; se = se->outlink) {
	      /* skip receiving edges */
	      if (se->label->name[0] == '+') continue;
	      /*create new state*/
	      se->reachable = 1;
	      if (newssarc(se, i, ssno, rgno)) return(1);
	   }
	j = (i == 1) ? 0 : 1;
	/* get the first msg from channel c[j], input channel of P[i] */
	/* see if there is outgoing edge that can receive this msg    */
	/*
	fprintf(stderr, "\tP[%d] at node %d check head msg=%s,\n", 
		i, ss[ssno].pn[i], ss[ssno].c[j].m); 
	*/
	if (strlen(ss[ssno].c[j].m) != 0) {
	   struct g_link	*re;  /* receiving edge */
	   struct g_node 	*node;
	   int    recmatch;

	   recmatch = F;
	   node = search_node(P[i].g, ss[ssno].pn[i]);
	   re = node->outlink;
	   for (; re != NULL; re = re->outlink) {
	      /* skip sending edges */
	      if (re->label->name[0] != '+') {
			continue;
			}
		  /*
		  fprintf(stderr, "\tP[%d] at Node %d head msg=%c, receiving edge=+%c, inputchannel=%s\n", i, ss[ssno].pn[i], ss[ssno].c[j].m[0], re->label->abn, ss[ssno].c[j].m);
		  */
	      if (ss[ssno].c[j].m[0] == re->label->abn) {
	         re->reachable = 1;
		 recmatch = T;
		 break;
		 }
	      }
	   if (recmatch == T) {
	      char CH[11];
	      int oldssno;

	      if (createss(re, i, ssno)) return(1);
	      /*receive first msg in channel c[j] */
	      strcpy(CH, &(ss[cssno].c[j].m[1]));
	      strcpy(ss[cssno].c[j].m, CH);
	      if (existeq(&oldssno, cssno)) {
		 cssno--;
		 tssno = (oldssno == 0) ? -99999 : -oldssno;
		 }
	      else {
		 ss[cssno].parentarcno = arc_no + 1;
	         tssno = cssno;
		 checkproperty(cssno, rgno);
		 }
	      }
	   else continue; /* check the other process */
	   append(&outstatelst, tssno);
	   if (insertarc(i, re, tssno, ssno)) return(1);
	   appendoutarc(arc_no);
	   } /* end of if c[j] not empty */
	} /* for */
	return(0);
}	

explore1level(expstatelst, rgno)
struct STATELST *expstatelst;
int rgno;
/*									
	input:	expstatelst
        output: outarclst, outgoing arcs of the states in expstatelst;
		outstatelst, outgoing states of the states in expstatelst,
			** Note that some of arcs may lead to the same states;
			** some of the states in outstatelst may be explored;
		updated rg[rgno] state lists.
									*/
{

	outarclst = (struct ARCLST *) NULL;
	outstatelst = (struct STATELST *) NULL;
	for (; expstatelst != NULL; expstatelst = expstatelst->next) 
	    if (explore1state(expstatelst->ssno, rgno)) return(1);
	return(0);
	
}


explore(expstateno, maxdepth, rgno)
int expstateno, maxdepth, rgno;
/* 									*/
/*	input: 	expstateno, the starting state # of state exploration 	*/
/*		maxdepth, max. of the depth of RG to be generated	*/
/*	output:	unexpstatelst, a list of unexplored states when state   */
/*			exploration reaches maxdepth.			*/	
/*		updated RG, 						*/
/*		updated problem states lists				*/
/*		a graph showing the RA result of this run.		*/
/*									*/
{
	struct STATELST *expstatelst;
	int depth;

	rg[rgno]->unexpstatelst = (struct STATELST *) NULL;
	expstatelst = NULL;
	append(&expstatelst, expstateno);
	draw_state_list(expstatelst, 0);
	for (depth = 1; (depth < maxdepth) && (expstatelst != NULL); depth++){
	   if (explore1level(expstatelst, rgno)) return(1);
	   draw_state_list(outstatelst, depth);
	   draw_arc_list(outarclst, depth, expstatelst, outstatelst);
	   expstatelst = outstatelst;
	   /* insert " ask for continue" command if in stepwise mode */
	   }
	insertunexpl(expstatelst, rgno);
	return(0);
}





