#include <stdio.h>
#include <xview/xview.h>
#include <sys/stat.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "menu.h"
#include "state.h"
#include "ext.h"
#include "extxv.h"

assign_node(lst)
struct STATELST *lst;
{
	struct g_node *node;

	for (node = g->first_node; node != 0; node = node->next) 
		if (node->ssno == lst->ssno) {
			lst->node = node;
			return;
			}
	lst->node = 0;	
	}

in_state_list(lst, ssno)
struct STATELST *lst;
int ssno;
{
	for (; lst != 0; lst = lst->next)
		if (lst->ssno == ssno) return(1);
	return(0);
}

highlight_error_states(rgno)
int rgno;
{
	struct STATELST *lst;
	Event  ie;
	Inputmask *im;

	im = (Inputmask *) xv_get(canvas_paint_window(canvas), WIN_INPUT_MASK);
	/* search for node in graph */
	for (lst = rg[rgno]->deadlock; lst != 0;  lst = lst->next) 
		assign_node(lst);
	for (lst = rg[rgno]->unspecified_reception; lst != 0;  lst = lst->next) 
		assign_node(lst);
	for (lst = rg[rgno]->proper_termination; lst != 0;  lst = lst->next) 
		assign_node(lst);
	for (lst = rg[rgno]->unexpstatelst; lst != 0;  lst = lst->next) 
		assign_node(lst);
	for (lst = rg[rgno]->deadlock; lst != 0;  lst = lst->next) 
		highlight_node(lst->node->x, lst->node->y);
	for (lst = rg[rgno]->unspecified_reception; lst != 0;  lst = lst->next) 
		highlight_node(lst->node->x, lst->node->y);
	for (lst = rg[rgno]->proper_termination; lst != 0;  lst = lst->next) 
		highlight_node(lst->node->x, lst->node->y);
	for (lst = rg[rgno]->unexpstatelst; lst != 0;  lst = lst->next) 
		if (in_state_list(rg[rgno]->unspecified_reception, lst->node->ssno) ||
in_state_list(rg[rgno]->deadlock, lst->node->ssno) || in_state_list(rg[rgno]->proper_termination, lst->node->ssno)) continue;
		else highlight_node(lst->node->x, lst->node->y);
	if (mode == MOVE_GRAPH) return;
	if (rg[rgno]->unexpstatelst == 0 && rg[rgno]->deadlock == 0 &&
		rg[rgno]->unspecified_reception == 0 &&
		rg[rgno]->proper_termination == 0) 
		return;
/*
	xv_input_readevent(canvas_paint_window(canvas), &ie, TRUE, TRUE, im);
	if (~win_inputnegevent(&ie) ) {
		switch (ie.ie_code) {
		case MS_MIDDLE :
		case CNTL_C :
			return;
			}
	}
	for (lst = rg[rgno]->deadlock; lst != 0;  lst = lst->next) 
		highlight_node(lst->node->x, lst->node->y);
	for (lst = rg[rgno]->unspecified_reception; lst != 0;  lst = lst->next) 
		highlight_node(lst->node->x, lst->node->y);
	for (lst = rg[rgno]->proper_termination; lst != 0;  lst = lst->next) 
		highlight_node(lst->node->x, lst->node->y);
	for (lst = rg[rgno]->unexpstatelst; lst != 0;  lst = lst->next) 
		if (in_state_list(rg[rgno]->unspecified_reception, lst->node->ssno) ||
in_state_list(rg[rgno]->deadlock, lst->node->ssno) || in_state_list(rg[rgno]->proper_termination, lst->node->ssno)) continue;
		else highlight_node(lst->node->x, lst->node->y);
*/
}
