#define F 0
#define T 1
#include <stdio.h>
#include <xview/xview.h>
#include <sys/stat.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"
#include "extxv.h"

show_path(ssno, i, y)
int ssno, i, y;
{
	struct ARCLST	*al;
	struct STATELST *sl;
	char	buf[10];
	int j, x;
	Font_string_dims dims;

	ssno = abs(ssno);
	if (ssno == 99999) ssno = 0;
	if (ss[ssno].parentarcno == -1) return(F);
	path[i].al = (struct ARCLST *) 0;
	for (; ss[ssno].parentarcno != -1; ) {
	    al = (struct ARCLST *) malloc(sizeof(struct ARCLST));
	    al->arcno = ss[ssno].parentarcno;
	    ssno = arc[al->arcno].srcssno;
	    al->next = path[i].al;
	    path[i].al = al;
	    }
	path[i].g = (struct GRAPH *) malloc(sizeof(struct GRAPH));
	init_g(path[i].g);
	path[i].g->type = PA;
	path[i].g->no = i;
	g = path[i].g;
	DX = 0; DY = 0;
	al = path[i].al;
	sl = (struct STATELST *) 0;
	append(&sl, arc[al->arcno].srcssno);
	sprintf(buf, "PATH %d", i);
	pwtext(4 +DX, y-35+DY, buf);
	x = 36;
	draw_state(sl, x, y);
	for (j = 1; al != 0; al = al->next, j++) {
	     struct g_link *link;
	     struct g_label *label;

	   link = (struct g_link *) malloc(G_LINK_SIZE);
	   label = (struct g_label *) malloc(G_LABEL_SIZE);
	   link->no = ++(g->link_no);
	   label->no = ++(g->label_no);
	   link->arcno = al->arcno;
	   link->src_port.x = x + 32;
	   link->src_port.y = y;
	   link->src_port.node = sl->node;
	   link->label = label;
	   i = strlen(arc[al->arcno].label) + 1;
	   label->name = (char *) malloc(i*sizeof(char));
	   strcpy(label->name, arc[al->arcno].label);
	   (void) xv_get(font, FONT_STRING_DIMS, label->name, &dims);
	   label->w = dims.width;
	   label->h = dims.width;
	   label->link = link;
	   label->next = (struct g_label *) 0;
	   label->x = x + 52;
	   label->y = y ;
	   insert_label(label);
	   link->rest_points = (struct g_rspt *) 0;
	   link->outlink = sl->node->outlink;
	   sl->node->outlink = link;
	   link->next =  (struct g_link *) 0;
	   sl = (struct STATELST *) 0;
	   append(&sl, arc[al->arcno].dstssno);
	   if (j != 6) {
	     link->dst_port.x = x + 112;
	     link->dst_port.y = y;
	     draw_vector(link->src_port.x, link->src_port.y, 
		      link->dst_port.x, link->dst_port.y);
	     write_edge_label(label);
	     x += 144;
	     draw_state(sl, x, y);
	     link->dst_port.node = sl->node;
	     link->inlink = sl->node->inlink;
	     sl->node->inlink = link;
	     }
	   else {
	     create_rspt(link, x + 72, y);
	     create_rspt(link, x + 72, y + 64);
	     create_rspt(link, 36, y + 64);
	     x = 36;
	     y = y + 128;
	     link->dst_port.x = x;
	     link->dst_port.y = y - 32;
	     draw_link(link);
	     write_edge_label(label);
	     draw_state(sl, x, y);
	     link->dst_port.node = sl->node;
	     link->inlink = sl->node->inlink;
	     sl->node->inlink = link;
	     j = 0;
	     }
	   insert_link(link);
	   }
	   return(T);
}

create_rspt(link, x, y)
struct g_link *link;
int x, y;
{
	struct g_rspt *f, *b, *rspt;

	     rspt = (struct g_rspt *) malloc(G_RSPT_SIZE);
	     rspt->no = ++(g->rspt_no);
	     rspt->x = x;
	     rspt->y = y;
	     rspt->link = link;
	     rspt->next_inlink = (struct g_rspt *) 0;
	     rspt->next = (struct g_rspt *) 0;
	     insert_rspt(rspt);
	     for (f = b = link->rest_points; f != 0; b = f, f = f->next_inlink); 
	     if (b != 0) b->next_inlink = rspt;
	     else link->rest_points = rspt;
}



	     
