
		switch(sw) {
		case READING_PROTOCOL_NAME:
			strcpy(protocol_name, name);
			strcpy(askname, "Enter the machine name : ");
			strcpy(name, process_name);
			nameptr = strlen(name)-1;
			namelength = PROTOCOL_NAME_LENGTH - 4;
			sw = READING_MACHINE_NAME;
			write_text(askname,name);
			return;
		case READING_MACHINE_NAME:
			strcpy(process_name, name);
			sprintf(file_name, "%s.%s", protocol_name, process_name);
			if (mode == LOAD) {
				release_objects();
				sprintf(buf, "Loading graph from %s", file_name);
				put_text_high(buf);
				load_file(file_name);
				
			} else if (mode == STORE) {
				if (file_name_ok(file_name) == 0) {
					reset_canvas_reader();
					return;
					}
				sprintf(buf, "Storing graph to %s", file_name);
				put_text_high(buf);
				store_file();
			} else if (mode == SAVE_SUB_GRAPH) {
				if (file_name_ok(file_name) == 0) {
					put_text("Please select the command in the middle button menu.");
					reset_canvas_reader();
					mode = 999;
					return;
					}
				put_text("Please point to the upper left conner of the sub-graph to be saved.");
				reset_canvas_reader();
				return;
				
			} else if (mode == CREATE_GRAPH) {
				if (file_name_ok(file_name) == 0) {
					reset_canvas_reader();
					return;
					}
			} else if (mode == PLACE_SUB_GRAPH) {
				canvas_reader = position_reader;
				put_text_high("Point to the upper left corner of the graph");
				put_text("  hit middle button for the upper left corner of the screen.");
				return;
			} else if (mode == EDIT_MACHINE) {
				if (g == P[0].g) strcpy(P[0].name, name);
				if (g == P[1].g) strcpy(P[1].name, name);
				draw_machine_name();
				}
			reset_canvas_reader();
			sleep(1);
			put_text_high("");
			return;
		case READING_NODE_LABEL :
			erase_node_label(node);
			free(node->label);
			i = strlen(name) + 1;
			node->label = node->label = (char *) malloc(i*sizeof(char));
			strcpy(node->label, name);
			write_node_label(node);
			reset_canvas_reader();
			put_text("Please point to the node whose label needs to be changed.");
			return;
		case REACHABILITY_ANALYSIS :
			if (mode == LOAD) {
				strcpy(protocol_name, name);
				load_protocol();
			}
			if (mode == STORE) {
				sprintf(buf, "%s.process.names", name);
				if (file_name_ok(buf) == 0) {
					reset_canvas_reader();
					return;
					}
				write_process_names(buf);
				write_machines(name);
				}
			if (mode == LOAD_RG) {
				strcat(name, ".rg");
				sprintf(buf, "Loading reachability graph to %s", name);
				put_text_high(buf);
				load_rg_from_file(name);	
				}
			if (mode == STORE_RG) {
				strcat(name, ".rg");
				if (file_name_ok(name) == 0) {
					reset_canvas_reader();
					return;
					}
				sprintf(buf, "Storing reachability graph to %s", name);	
				put_text_high(buf);
				store_rg_to_file(name);
				}
			reset_canvas_reader();
			sleep(1);
			put_text_high("");
			return;
		}
