#include <stdio.h>
#include <xview/xview.h>
#include <xview/cms.h>
#include "tool.h"
#include "g.h"
#include "ext.h"
#include "extxv.h"

Display *display;
Drawable drawable;
Display *gdisplay;
Window  gwin;
GC gcClear;
GC gcSet;
GC gcDraw;
GC gcErase;
GC gcINV;
GC gcSRC;
GC gcHighlight;
GC gcf;
GC gcf6;
GC gcfSRC;
GC gcf6SRC;
GC gcfCLR;
GC gcf6CLR;

#define BLACK 	7
#define WHITE 	0
#define RED		1

init_GC()
{
	XGCValues gc_val;
	XFontStruct *fs;
	XColor white, black;

	white.red = 255, white.green = 255, white.blue = 255;
	black.red = 0, black.green = 0, black.blue = 0;

	display=(Display *)xv_get(canvas_paint_window(canvas), XV_DISPLAY);
    drawable = (Drawable)xv_get(canvas_paint_window(canvas),XV_XID);
	/*
	(void) xv_set(canvas_paint_window(canvas), 
				WIN_CMS_NAME, "palette",
				WIN_CMS_DATA, &cms_data,
				WIN_FOREGROUND_COLOR, BLACK,
				WIN_BACKGROUND_COLOR, WHITE,
				0);
	*/
	fprintf(stderr, "after xv_get display and drawable.\n");
    gc_val.function = GXset;
    /* gc_val.foreground = WhitePixel(display, DefaultScreen(display)); */
    gcSet = XCreateGC(display, drawable, GCFunction , &gc_val);
    gc_val.function = GXclear;
    /* gc_val.foreground = WhitePixel(display, DefaultScreen(display)); */
    gcClear = XCreateGC(display, drawable, GCFunction , &gc_val);
	fprintf(stderr, "after create gcClear.\n");
    gc_val.function = GXxor;
    gcINV = XCreateGC(display, drawable,
            GCFunction|GCForeground, &gc_val);
            
    gc_val.function = GXcopy;
    gcSRC = XCreateGC(display, drawable,
            GCFunction|GCForeground|GCBackground, &gc_val);
	/* 
    gc_val.function = GXclear;
	*/
    gc_val.function = GXset;
    gcErase = XCreateGC(display, drawable,
            GCFunction|GCForeground, &gc_val);
    gc_val.function = GXinvert;
    gcHighlight = XCreateGC(display, drawable,
            GCFunction|GCFunction|GCForeground, &gc_val);
	fs = (XFontStruct *) xv_get(font, FONT_INFO);
	gc_val.font = fs->fid;
	gc_val.function = GXxor;
	gcf = XCreateGC(display, drawable, 
			GCFont|GCFunction|GCForeground, &gc_val);
	gcfSRC = gcf;
	gcfCLR = gcf;
	fs = (XFontStruct *) xv_get(font6, FONT_INFO);
	gc_val.font = fs->fid;
	gcf6 = XCreateGC(display, drawable, 
			GCFont|GCFunction|GCForeground, &gc_val);
	gcf6CLR = gcf6;
	gcf6SRC = gcf6;
    gc_val.function = GXcopyInverted;
    gcDraw = XCreateGC(display, drawable,
            GCFunction|GCForeground|GCBackground, &gc_val);
	gc_val.function = GXclear;
	gcfCLR = XCreateGC(display, drawable, 
			GCFont|GCFunction|GCForeground|GCBackground, &gc_val);
}

void
put_text( text)
char     text[];
{
	xv_set(txtmsg_item, PANEL_LABEL_STRING, text, 0);
}

void
put_text_high( text)
char     text[];
{
	xv_set(hightxtmsg_item, PANEL_LABEL_STRING, text, 0);
	}

void
put_text_higher( text)
char     text[];
{
	xv_set(highertxtmsg_item, PANEL_LABEL_STRING, text, 0);
	}

clear_msg()
{
	put_text("");
	put_text_high("");
	put_text_higher("");
}

pwtext(x, y, text1)
int x, y;
char text1[];
{

	switch(zoom) {
	case 1:	
		XDrawString(display, drawable, gcf, x, y, text1, strlen(text1));
		break;
	case 2:	
		XDrawString(display, drawable, gcf6, x, y, text1, strlen(text1));
		break;
	case 4:
	case 8:
	case 16:	return;
	}
}

pwtextCLR(x, y, text1)
int x, y;
char text1[];
{

	switch(zoom) {
	case 1:	
		XDrawString(display, drawable, gcfCLR, x, y, text1, strlen(text1));
		break;
	case 2:	
		XDrawString(display, drawable, gcf6CLR, x, y, text1, strlen(text1));
		break;
	case 4:
	case 8:
	case 16:	return;
	}
}

pwtextSRC(x, y, text1)
int x, y;
char text1[];
{

	switch(zoom) {
	case 1:	
		XDrawString(display, drawable, gcSRC, x, y, text1, strlen(text1));
		break;
	case 2:	
		XDrawString(display, drawable, gcf6SRC, x, y, text1, strlen(text1));
		break;
	case 4:
	case 8:
	case 16:	return;
	}
}


static	char buf1[80];

write_text(s1,s2)
char *s1,*s2;
{	 

	sprintf(buf1,"%s%s",s1,s2);
	put_text(buf1); 
}	

