#define         BIG             2048
#define         TOOL_WIDTH    1052
#define         TOOL_HEIGHT   900
#define         PDS_CANVAS_WIDTH    1042
#define         PDS_CANVAS_HEIGHT   835
#define		MSG_HEIGHT      24

#define         CNTL_C          3
#define         CNTL_H          8
#define         CNTL_U          21
#define         DEL             127
#define         CR              13

#define         PAINT_OP        PIX_SRC | PIX_DST
#define         INV_PAINT_OP    PIX_SRC ^ PIX_DST
#define         WRITE_OP        PIX_SRC

#define SOLID    0
#define SPEAR    1
#define NO_ARROW_HEAD     2

#define DELICATE 0
#define FAST 1

#define UNI_DIRECTIONAL 0
#define BI_DIRECTIONAL 1

#define DIRECTED 0
#define UN_DIRECTED 1

#define 	NOPAR 		0

#define TOOL_NAME_LENGTH 150
#define FILENAME_LENGTH 200
#define PROTOCOL_NAME_LENGTH 60
#define MACHINE_NAME_LENGTH 40
#define ASKNAME_LENGTH 80 
#define NAME_LENGTH 80
#define BUF_LENGTH 200
#define LABELNAME_LENGTH 100
#define NODE_LABEL_LENGTH 	9
/***  sw value for name_reader **/
#define 		READING_PROTOCOL_NAME	1
#define			READING_NODE_LABEL	2
#define 		READING_NO_OF_MACHINES	3
#define 		READING_MACHINE_NAME	4
#define			REACHABILITY_ANALYSIS	5
#define         INIT            6
#define         EXPL            7

/***  sw value for move node and move subgraph ***/

#define  DRAW_NODELINKS		4
#define	 ERASE_NODELINKS	5
#define	 RELOCATE_NODE		6

/***** template constant *********/
#define         TP_SIZE         32
#define         TP_HALF         TP_SIZE / 2
#define         STP_SIZE        64
#define         STP_HALF        STP_SIZE / 2
#define		TP_STRSIZE	16
#define 	MAX_TEMPLATE    32
#define		MAX_PORT	32

/**** reachability graph constant ***/
#define MAXSSNO         1000
#define MAXARCNO        2000
#define MAXCHANNELMSG   10

#define MSGSEQ_LENGTH 11 
#define REACHABILITY_SUBGRAPH_NO   50
#define PATH_NO			20
#define MSG_TABLE_ENTRY_NO	50
#define SHORT_NAME_TBL_ENTRY_NO 79
#define STATE_PROPERTY_LENGTH   24
#define MSG_NAME_LENGTH		10
