#include <stdio.h>
#include <xview/xview.h>
#include <sys/stat.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "menu.h"
#include "ext.h"
#include "extxv.h"

init_comment_reader(ie)
Event *ie;
{
	int x,y;

	strcpy(labelname, "");
	labelptr = -1;
	put_text_higher("Please enter the comment.");
	put_text_high("   Drag the label with the left button down.");
	put_text("   Hit the middle button or return to exit. ");
	x = ie->ie_locx;
	y = ie->ie_locy;
	/* winsetmouseposition(cswfd, x, y); */
	cur_x = x;
	cur_y = y;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, label_cursor, 0);
	canvas_reader = edge_label_reader;
}

init_change_comment(ie)
Event *ie;
{


	label = label_search(ie->ie_locx, ie->ie_locy);
	if (label == 0 ) {
		reset_canvas_reader();
		return;
		}
	if (label->link != 0) {
		put_text_high("It is not a comment!");
		reset_canvas_reader();
		return;
		}
	strcpy(labelname, label->name);
	free(label->name);
	label->name = 0;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, label_cursor, 0);
	cur_link = 0;
	cur_x = label->x;
	cur_y = label->y;
	delete_label(label);
	/* winsetmouseposition(cswfd, cur_x, cur_y); */
	labelptr = strlen(labelname) - 1;
	put_text_higher("Please correct the comment;");
	put_text_high("   drag it with left button down;");
	put_text("   hit middle button or return to exit.");
	canvas_reader = edge_label_reader;
}

write_mark(L)
struct g_label *L;
{
	pwtext(L->x + DX - 7, L->y + 6 + DY, "*");	
}

show_comment()
{
	struct g_label *l;

	for (l = first_label; l != 0; l = l->next) 
		if (l->link == 0) 
			write_mark(l);
}

remove_comment(ie)
Event *ie;
{
	int x,  y;
	struct g_label *label;

	label = label_search(ie->ie_locx, ie->ie_locy);
	if (label != 0) {
		if (label->link == 0) {
			write_mark(label);
			erase_edge_label(label);
			delete_label(label);
			free_label(label);
			}
	}
	show_comment();
	reset_canvas_reader();
	mode = 999;
	put_text("Please select the command in the middle button menu.");
}



