extern struct tool      *tool;
extern struct GRAPH	*g; 
extern struct GRAPH	*g1; 
extern int cssno;
extern struct STATE  	ss[];
extern int arc_no;
extern struct ARC	arc[];
extern int node_no;
extern int link_no;
extern int rspt_no;
extern int label_no;

extern int DX, DY, oldDX, oldDY;
extern double hpi;
extern int               X, Y, x, y, cur_x, cur_y, fix_x, fix_y;
extern int              (*canvas_reader) ();
extern int 		  detail_state_reader();
extern                  edge_label_reader();
extern                  rest_point_reader();
extern                  area_reader();
extern                   move_area_reader();
extern                   position_reader();
extern int              (*menu_selected) ();
extern int     menu1_selected ();
extern int     menu2_selected ();
extern int     menu3_selected ();
extern int     menu5_selected ();
extern int     edit_menu_selected ();
extern int               zoom;
extern int               oldzoom;
extern int graph_type;
extern int arrow_head_drawing_mode;
extern int save_arrow_head_drawing_mode;
extern int link_drawing_mode;
extern int save_link_drawing_mode;

extern int                number_reader ();
extern void 			modified();
extern int                name_reader ();


extern                  node_tracker();
extern                  link_tracker();
extern                  common_tracker();
extern                  movegraph_tracker();
extern                  movenode_tracker();
extern                  movelink_tracker();

extern struct g_node    *node_highlighted;
extern struct g_node    *node;
extern struct g_node    *node_search();
extern struct g_node    *search_node();
extern struct g_node    *first_node;
extern struct g_node    *initial_node;

extern int               link_type;
extern struct g_link    *link_highlighted;
extern struct g_link    *link;
extern struct g_link    *cur_link;
extern struct g_link   *link_search();
extern struct g_link    *last_link;
extern struct g_link    *first_link;

extern struct g_rspt    *rest_point;
extern struct g_rspt    *rspt;
extern struct g_rspt   *last_restpt();
extern struct g_rspt   *first_rspt;
extern struct g_rspt   *rspt_search();

extern struct g_label   *first_label;
extern struct g_label   *label_search();
extern struct g_label   *label;

extern struct NODE_LIST *node_list;
extern struct LINK_LIST *link_list;
extern struct RSPT_LIST *rspt_list;
extern struct LABEL_LIST *label_list;

extern int           mode;



extern char             tool_name[];
extern char             askname[];
extern char             name[];
extern short            nameptr;
extern short            namelength;
extern char             no[];
extern short            noptr;
extern int              number;
extern short            sw;
extern char              labelname[];
extern short             labelptr;
extern char              protocol_name[];
extern char              process_name[];
extern char              filename[];
extern int               channel_type;
extern int               topology;
extern int               command;

extern char             buf[];



extern struct  PROCESS   P[]; /* process names */
extern int	machine_exist[2];

extern struct  Rg	*rg[];
extern int		 rg_exist;
extern int     		 cur_rgno;
extern int 		 rgno;

extern struct PATH     path[];
extern int 		 cur_pathno;
extern int msgno;      /* current no of msgs in msgtbl */
extern struct MSGTBL    msgtbl[];
extern char abnuse[];

extern char              file_name[];
extern char             buf[];
extern struct STATELST	*outstatelst;
extern struct ARCLST	*outarclst;

