#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/font.h>
#include <xview/cursor.h>
#include <xview/cms.h>
#include <X11/X.h>
#include <X11/Xlib.h>

extern Frame frame;
extern Frame subframe;
extern Frame protocolFrame;
extern Canvas canvas;
extern Display *display;
extern Drawable drawable;
extern GC gcClear;
extern GC gcDraw;
extern GC gcErase;
extern GC gcINV;
extern GC gcHighlight;
extern GC gcf;

extern char font_name[];
extern Xv_Font font;
extern Xv_Font font6;
extern char font6_name[];

extern Xv_Cursor   label_cursor;
extern Xv_Cursor   node_cursor;
extern Xv_Cursor   link_cursor;
extern Xv_Cursor   paint_cursor;
extern Xv_Cursor   wait_cursor;
extern Xv_Cursor   cur_cursor;

extern Xv_cmsdata  cms_data;

extern Panel panel;
extern Panel_item msg_item;
extern Panel_item txtmsg_item; /* replace the old msw */
extern Panel_item hightxtmsg_item; /* replace the old msw */
extern Panel_item highertxtmsg_item; /* replace the old msw */

extern Panel popupPanel;
extern Panel_item popupMsg_item;
extern Panel_item popupData_item; /* replace the old msw */
extern Panel_item popupData2_item; /* replace the old msw */

extern Menu menu1;
extern Menu menu2;
extern Menu edit_menu;

extern void popupData_proc();

extern Pixmap initial_node_pixmap;
extern Pixmap xbitmap[13];

