/************** main menu of iratool **********/

#define		LOAD		 2
#define		STORE		 3
#define		MOVE_GRAPH	 4
#define		PLACE_SUB_GRAPH	 5
#define		SAVE_SUB_GRAPH	 6
#define		MOVE_SUB_GRAPH	 7
#define		REMOVE_SUB_GRAPH	 8
#define		PLACE_NODE	 9
#define		MOVE_NODE	 10
#define		REMOVE_NODE	 11
#define		CHANGE_NODE_LABEL  12
#define		PLACE_BUS	 13
#define		MOVE_BUS	 14
#define		REMOVE_BUS	 15
#define		CHANGE_BUS_LABEL  16 
#define		PLACE_RING	 17 
#define		CONNECT_M_TO_BUS  18
#define		PLACE_LINK	 19
#define		MOVE_LINK	 20
#define		REMOVE_LINK	 21
#define		CHANGE_LINK_LABEL  22
#define		DIRECTIONAL_LINK  23
#define		BI_DIRECTIONAL_LINK  24
#define		SHOW_DESCRIPTION	 25
#define		CHANGE_DESCRIPTION	 26
#define		EDIT_MACHINE   	 27
#define 	ENTER_COMMENT	 28
#define 	CHANGE_COMMENT	 29
#define 	REMOVE_COMMENT	 30
#define		REDISPLAY	 31
#define		CLEAR		 32
#define 	MOVE_LOOP	 200
#define		REMOVE_LOOP	 201
#define		CHANGE_INITIAL_NODE	 202

#define         EXPLORE          212
#define         SHOW_PATH        213
#define         DETAIL           214
#define         TOPOLOGY         215
#define         SHOW_RG          216

#define         PLACERG          221
#define         DRAW_RG          222
#define         POS_PATH         223

#define         DETAIL2          224
#define         SLOW             225
#define         QUICK             226
#define         MANUAL           227
#define         QUIT             228

#define         AGGREGATE        229
#define         PROJECT          230
#define         WELL_FORM        231

#define         PRINT_MSGTBL     232
#define         ANALYZE    	 233

#define 	LOAD_RG		 234
#define 	STORE_RG	 235
#define 	MOVE_RG	 	 236

#define		MACHINE_EXIST	 237
#define		LOAD_GRAPH		 238
#define		STORE_GRAPH		 239
#define		CREATE_GRAPH  	240
#define		CREATE_PROTOCOL  241
#define		SHOW_PROTOCOL  242

/**********  channel link type ***************/

#define 	LINE		 100
#define		B_SPLINE	101
#define 	T_SPLINE	102
#define		LOOP		103

/**********  zooming constant *************/

#define		ZOOM		37
#define 	HALF		38
#define 	QUAR		39
#define		EIGHTH		40
#define		NORMAL		41
#define		DOUBLE		42
#define		SIXTEENTH	47

/*********   types of regular topology *************/

#define		COMPLETE	43
#define		SINGLE_LOOP	44
#define		DOUBLE_LOOP	45

#define		FROM_FILE	46

