#include <stdio.h>
#include <xview/xview.h>
#include <sys/stat.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"

fp(fd, ssno)
FILE *fd;
int   ssno;
{
	register int s;

	s = abs(ssno);
	if (s == 99999) s = 0;
	fprintf(fd, "%d ", s);
}

print_statistics(rgno)
int rgno;
{
	int i;
	FILE *fd;
	struct STATELST	*sl;
	struct rect rect, recticon;

	fd = fopen("statistics", "w");
	fprintf(fd, "The statistics of RG[%d].\n\n", rgno);
	for (i = 0, sl = rg[rgno]->deadlock; sl != NULL; sl = sl->next, i++);
	fprintf(fd, "There are %d deadlock states in this subRG:\n", i);
	for (sl = rg[rgno]->deadlock; sl != NULL; sl = sl->next)
	   fp(fd, sl->ssno);
	for (i = 0, sl = rg[rgno]->unspecified_reception; sl != NULL; sl = sl->next, i++);
	fprintf(fd, "\n\nThere are %d unspecified_reception states:\n",i);
	for (sl = rg[rgno]->unspecified_reception; sl != NULL; sl = sl->next)
	   fp(fd, sl->ssno);
	for (i = 0, sl = rg[rgno]->proper_termination; sl != NULL; sl = sl->next, i++);
	fprintf(fd, "\n\nThere are %d proper_termination states:\n",i);
	for (sl = rg[rgno]->proper_termination; sl != NULL; sl = sl->next)
	   fp(fd, sl->ssno);
	for (i = 0, sl = rg[rgno]->unexpstatelst; sl != NULL; sl = sl->next, i++);
	fprintf(fd, "\n\nThere are %d unexplored states:\n",i);
	for (sl = rg[rgno]->unexpstatelst; sl != NULL; sl = sl->next)
	   fp(fd, sl->ssno);
	fprintf(fd,"\n");	
	fclose(fd);
	/* use forktool to create msgtable window */

	fd = fopen("command", "w");
	if (fd == NULL) return;
	fprintf(fd, "vi statistics");
	fclose(fd);
	system("chmod 777 command");
	rect.r_left = 750;
	rect.r_top  = 631;
	rect.r_width  = 402;
	rect.r_height = 260;
	recticon.r_left = 1080;
	recticon.r_top  = 207;
	recticon.r_width  = 64;
	recticon.r_height = 64;
	(void) wmgr_forktool("pvrtool", "-c command", &rect, &recticon, 0); 
}

